/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32u5xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "n25q128a.h"
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */
#define BUFFERSIZE                 (COUNTOF(aTxBuffer) - 1)
#define COUNTOF(__BUFFER__)        (sizeof(__BUFFER__) / sizeof(*(__BUFFER__)))
#define QSPI_END_ADDR              (1 << 23)
/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define Overload_Pin GPIO_PIN_13
#define Overload_GPIO_Port GPIOC
#define HF_Protection_uP_Pin GPIO_PIN_14
#define HF_Protection_uP_GPIO_Port GPIOC
#define DC_Offset_uP_Pin GPIO_PIN_15
#define DC_Offset_uP_GPIO_Port GPIOC
#define Temp_Sensor_Pin GPIO_PIN_2
#define Temp_Sensor_GPIO_Port GPIOF
#define Rel_ON_OFF_Pin GPIO_PIN_3
#define Rel_ON_OFF_GPIO_Port GPIOF
#define Rel_Roff_Pin GPIO_PIN_4
#define Rel_Roff_GPIO_Port GPIOF
#define T_Rel_SPK_Pin GPIO_PIN_5
#define T_Rel_SPK_GPIO_Port GPIOF
#define TFT_ON_OFF_Pin GPIO_PIN_1
#define TFT_ON_OFF_GPIO_Port GPIOH
#define BLK_PWM_Pin GPIO_PIN_0
#define BLK_PWM_GPIO_Port GPIOC
#define LCD_Reset_Pin GPIO_PIN_3
#define LCD_Reset_GPIO_Port GPIOC
#define SPI_CS_Pin GPIO_PIN_3
#define SPI_CS_GPIO_Port GPIOA
#define Taste_Power_Pin GPIO_PIN_0
#define Taste_Power_GPIO_Port GPIOB
#define IR_Remote_Pin GPIO_PIN_1
#define IR_Remote_GPIO_Port GPIOB
#define SW_OUT3L_Pin GPIO_PIN_12
#define SW_OUT3L_GPIO_Port GPIOF
#define SW_OUT2L_Pin GPIO_PIN_13
#define SW_OUT2L_GPIO_Port GPIOF
#define SW_OUT1L_Pin GPIO_PIN_14
#define SW_OUT1L_GPIO_Port GPIOF
#define SW_OUT3R_Pin GPIO_PIN_15
#define SW_OUT3R_GPIO_Port GPIOF
#define SW_OUT2R_Pin GPIO_PIN_0
#define SW_OUT2R_GPIO_Port GPIOG
#define SW_OUT1R_Pin GPIO_PIN_1
#define SW_OUT1R_GPIO_Port GPIOG
#define SD_Card_Detect_Pin GPIO_PIN_11
#define SD_Card_Detect_GPIO_Port GPIOB
#define CLK_4094_Tastatur_Pin GPIO_PIN_13
#define CLK_4094_Tastatur_GPIO_Port GPIOB
#define DATA_4094_Tastatur_Pin GPIO_PIN_14
#define DATA_4094_Tastatur_GPIO_Port GPIOB
#define CS_4094_Tastatur_Pin GPIO_PIN_15
#define CS_4094_Tastatur_GPIO_Port GPIOB
#define Blank_Pin GPIO_PIN_2
#define Blank_GPIO_Port GPIOG
#define SCLK_D_Pin GPIO_PIN_3
#define SCLK_D_GPIO_Port GPIOG
#define LAT_Pin GPIO_PIN_4
#define LAT_GPIO_Port GPIOG
#define Display_DATA_Pin GPIO_PIN_5
#define Display_DATA_GPIO_Port GPIOG
#define Taste_Menue_Pin GPIO_PIN_6
#define Taste_Menue_GPIO_Port GPIOG
#define Taste_MONO_Pin GPIO_PIN_7
#define Taste_MONO_GPIO_Port GPIOG
#define Taste_SPK_Pin GPIO_PIN_8
#define Taste_SPK_GPIO_Port GPIOG
#define USB_Connected_Pin GPIO_PIN_4
#define USB_Connected_GPIO_Port GPIOD
#define USB_Mute_Pin GPIO_PIN_5
#define USB_Mute_GPIO_Port GPIOD
#define DSD64_128_Pin GPIO_PIN_6
#define DSD64_128_GPIO_Port GPIOD
#define DSD_ON_Pin GPIO_PIN_7
#define DSD_ON_GPIO_Port GPIOD
#define F0_Pin GPIO_PIN_9
#define F0_GPIO_Port GPIOG
#define F1_Pin GPIO_PIN_10
#define F1_GPIO_Port GPIOG
#define F2_Pin GPIO_PIN_12
#define F2_GPIO_Port GPIOG
#define F3_Pin GPIO_PIN_15
#define F3_GPIO_Port GPIOG
#define ES_GPIO1_Pin GPIO_PIN_5
#define ES_GPIO1_GPIO_Port GPIOB
#define CS_2311_Pin GPIO_PIN_6
#define CS_2311_GPIO_Port GPIOB
#define DATA_2311_Pin GPIO_PIN_7
#define DATA_2311_GPIO_Port GPIOB
#define CLK_2311_Pin GPIO_PIN_3
#define CLK_2311_GPIO_Port GPIOH
#define CLK_4098_Pin GPIO_PIN_8
#define CLK_4098_GPIO_Port GPIOB
#define DATA_4098_Pin GPIO_PIN_9
#define DATA_4098_GPIO_Port GPIOB
#define CS_4098_Pin GPIO_PIN_1
#define CS_4098_GPIO_Port GPIOE

/* USER CODE BEGIN Private defines */
#define CLK_4094_ON()   HAL_GPIO_WritePin(CLK_4094_Tastatur_GPIO_Port, CLK_4094_Tastatur_Pin, GPIO_PIN_SET)// Output Datenleitung
#define DATA_4094_ON()    HAL_GPIO_WritePin(DATA_4094_Tastatur_GPIO_Port, DATA_4094_Tastatur_Pin, GPIO_PIN_SET)// Output Clock
#define CS_4094_ON()    HAL_GPIO_WritePin(CS_4094_Tastatur_GPIO_Port, CS_4094_Tastatur_Pin, GPIO_PIN_SET)// Output Latch

#define CLK_4094_OFF()   HAL_GPIO_WritePin(CLK_4094_Tastatur_GPIO_Port, CLK_4094_Tastatur_Pin, GPIO_PIN_RESET)// Output Datenleitung
#define DATA_4094_OFF()    HAL_GPIO_WritePin(DATA_4094_Tastatur_GPIO_Port, DATA_4094_Tastatur_Pin, GPIO_PIN_RESET)// Output Clock
#define CS_4094_OFF()    HAL_GPIO_WritePin(CS_4094_Tastatur_GPIO_Port, CS_4094_Tastatur_Pin, GPIO_PIN_RESET)// Output Latch
/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
