/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "crc.h"
#include "dcache.h"
#include "icache.h"
#include "octospi.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "n25q128a.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
__IO uint8_t CmdCplt, RxCplt, TxCplt, StatusMatch;

/* Buffer used for transmission */
uint8_t aTxBuffer[] = " ****Memory-mapped QSPI communication****  ****Memory-mapped QSPI communication****  ****Memory-mapped QSPI communication****  ****Memory-mapped QSPI communication****  ****Memory-mapped QSPI communication****  ****Memory-mapped QSPI communication**** ";

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void SystemPower_Config(void);
/* USER CODE BEGIN PFP */
static void QSPI_WriteEnable(OSPI_HandleTypeDef *hqspi);
static void QSPI_AutoPollingMemReady(OSPI_HandleTypeDef *hqspi);
static void QSPI_DummyCyclesCfg(OSPI_HandleTypeDef *hqspi);
void clock_4094(void);
void strobe_4094(void);
void data_submit_4094(uint8_t LED_data);
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
	OSPI_RegularCmdTypeDef      sCommand;
	OSPI_MemoryMappedTypeDef sMemMappedCfg;
	  uint32_t address = 0;
	  __IO uint8_t *qspi_addr = (__IO uint8_t *)(0x90000000);
	  uint16_t index;
	  __IO uint8_t step = 0;
  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* Configure the System Power */
  SystemPower_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_CRC_Init();
  MX_OCTOSPI1_Init();
  MX_ICACHE_Init();
  MX_DCACHE1_Init();
  /* USER CODE BEGIN 2 */
  data_submit_4094(0b00000000);// LED OFF

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
	  switch(step)
	     {
	       case 0:
	         CmdCplt = 0;

	         /* Initialize QuadSPI ------------------------------------------------ */
	         HAL_OSPI_DeInit(&hospi1);
	         if (HAL_OSPI_Init(&hospi1) != HAL_OK)
	         {
	           Error_Handler();
	         }

	         /* Enable write operations ------------------------------------------- */
	         QSPI_WriteEnable(&hospi1);

	         /* Erasing Sequence -------------------------------------------------- */
	         sCommand.Instruction = SECTOR_ERASE_CMD;
	         sCommand.AddressMode = HAL_OSPI_ADDRESS_1_LINE;
	         sCommand.Address     = address;
	         sCommand.DataMode    = HAL_OSPI_DATA_NONE;
	         sCommand.DummyCycles = 0;

	         if (HAL_OSPI_Command_IT(&hospi1, &sCommand) != HAL_OK)
	         {
	           Error_Handler();
	         }

	         step++;
	         break;

	       case 1:
	         if(CmdCplt != 0)
	         {
	           CmdCplt = 0;
	           StatusMatch = 0;

	           /* Configure automatic polling mode to wait for end of erase ------- */
	           QSPI_AutoPollingMemReady(&hospi1);

	           step++;
	         }
	         break;

	       case 2:
	         if(StatusMatch != 0)
	         {
	           StatusMatch = 0;
	           TxCplt = 0;

	           /* Enable write operations ----------------------------------------- */
	           QSPI_WriteEnable(&hospi1);

	           /* Writing Sequence ------------------------------------------------ */
	           sCommand.Instruction = QUAD_IN_FAST_PROG_CMD;
	           sCommand.AddressMode = HAL_OSPI_ADDRESS_1_LINE;
	           sCommand.DataMode    = HAL_OSPI_DATA_4_LINES;
	           sCommand.NbData      = BUFFERSIZE;

	           if (HAL_OSPI_Command(&hospi1, &sCommand, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
	           {
	             Error_Handler();
	           }

	           if (HAL_OSPI_Transmit_DMA(&hospi1, aTxBuffer) != HAL_OK)
	           {
	             Error_Handler();
	           }

	           step++;
	         }
	         break;

	       case 3:
	         if(TxCplt != 0)
	         {
	           TxCplt = 0;
	           StatusMatch = 0;

	           /* Configure automatic polling mode to wait for end of program ----- */
	           QSPI_AutoPollingMemReady(&hospi1);

	           step++;
	         }
	         break;

	       case 4:
	         if(StatusMatch != 0)
	         {
	           StatusMatch = 0;
	           RxCplt = 0;

	           /* Configure Volatile Configuration register (with new dummy cycles) */
	           QSPI_DummyCyclesCfg(&hospi1);

	           /* Reading Sequence ------------------------------------------------ */
	           sCommand.Instruction = QUAD_OUT_FAST_READ_CMD;
	           sCommand.DummyCycles = N25Q128A_DUMMY_CYCLES_READ_QUAD;

	           sMemMappedCfg.TimeOutActivation = HAL_OSPI_TIMEOUT_COUNTER_DISABLE;
	           if (HAL_OSPI_MemoryMapped(&hospi1, &sMemMappedCfg) != HAL_OK)
	           //if (HAL_OSPI_MemoryMapped(&hospi1, &sCommand) != HAL_OK) //, &sMemMappedCfg
	           {
	             Error_Handler();
	           }

	           for (index = 0; index < BUFFERSIZE; index++)
	           {
	             if (*qspi_addr != aTxBuffer[index])
	             {
	            	 data_submit_4094(0b01000000);// LED green
	             }
	             qspi_addr++;
	           }
	           data_submit_4094(0b10000000);// LED red

	           address += N25Q128A_PAGE_SIZE;
	           if(address >= QSPI_END_ADDR)
	           {
	             address = 0;
	           }
	           qspi_addr = (__IO uint8_t *)(0x90000000 + address);

	           step = 0;
	         }
	         break;

	       default :
	         Error_Handler();

	     }
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_BYPASS;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMBOOST = RCC_PLLMBOOST_DIV1;
  RCC_OscInitStruct.PLL.PLLM = 1;
  RCC_OscInitStruct.PLL.PLLN = 10;
  RCC_OscInitStruct.PLL.PLLP = 8;
  RCC_OscInitStruct.PLL.PLLQ = 2;
  RCC_OscInitStruct.PLL.PLLR = 1;
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLLVCIRANGE_1;
  RCC_OscInitStruct.PLL.PLLFRACN = 0;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2
                              |RCC_CLOCKTYPE_PCLK3;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB3CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief Power Configuration
  * @retval None
  */
static void SystemPower_Config(void)
{
  HAL_PWREx_EnableVddIO2();

  /*
   * Disable the internal Pull-Up in Dead Battery pins of UCPD peripheral
   */
  HAL_PWREx_DisableUCPDDeadBattery();
/* USER CODE BEGIN PWR */
/* USER CODE END PWR */
}

/* USER CODE BEGIN 4 */
void HAL_QSPI_CmdCpltCallback(OSPI_HandleTypeDef *hqspi)
{
  CmdCplt++;
}

/**
  * @brief  Rx Transfer completed callbacks.
  * @param  hqspi: QSPI handle
  * @retval None
  */
void HAL_QSPI_RxCpltCallback(OSPI_HandleTypeDef *hqspi)
{
  RxCplt++;
}

/**
  * @brief  Tx Transfer completed callbacks.
  * @param  hqspi: QSPI handle
  * @retval None
  */
void HAL_QSPI_TxCpltCallback(OSPI_HandleTypeDef *hqspi)
{
  TxCplt++;
}

/**
  * @brief  Status Match callbacks
  * @param  hqspi: QSPI handle
  * @retval None
  */
void HAL_QSPI_StatusMatchCallback(OSPI_HandleTypeDef *hqspi)
{
  StatusMatch++;
}

/**
  * @brief  This function send a Write Enable and wait it is effective.
  * @param  hqspi: QSPI handle
  * @retval None
  */
static void QSPI_WriteEnable(OSPI_HandleTypeDef *hqspi)
{
	OSPI_RegularCmdTypeDef     sCommand;
	OSPI_AutoPollingTypeDef sConfig;

  /* Enable write operations ------------------------------------------ */
  sCommand.InstructionMode   = HAL_OSPI_INSTRUCTION_1_LINE;
  sCommand.Instruction       = WRITE_ENABLE_CMD;
  sCommand.AddressMode       = HAL_OSPI_ADDRESS_NONE;
  sCommand.AlternateBytesMode = HAL_OSPI_ALTERNATE_BYTES_NONE;
  sCommand.DataMode          = HAL_OSPI_DATA_NONE;
  sCommand.DummyCycles       = 0;
  sCommand.DataDtrMode           = HAL_OSPI_DATA_DTR_DISABLE;
  sCommand.DQSMode  		= HAL_OSPI_DQS_DISABLE;
  sCommand.SIOOMode          = HAL_OSPI_SIOO_INST_EVERY_CMD;

  if (HAL_OSPI_Command(&hospi1, &sCommand, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  {
    Error_Handler();
  }

  /* Configure automatic polling mode to wait for write enabling ---- */
  sConfig.Match           = 0x02;
  sConfig.Mask            = 0x02;
  sConfig.MatchMode       = HAL_OSPI_MATCH_MODE_AND;
//  sConfig.StatusBytesSize = 1;
  sConfig.Interval        = 0x10;
  sConfig.AutomaticStop   = HAL_OSPI_AUTOMATIC_STOP_ENABLE;

  sCommand.Instruction    = READ_STATUS_REG_CMD;
  sCommand.DataMode       = HAL_OSPI_DATA_1_LINE;
 // if (HAL_OSPI_AutoPolling(&hospi1, &sCommand, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  if (HAL_OSPI_AutoPolling(&hospi1, &sConfig, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief  This function read the SR of the memory and wait the EOP.
  * @param  hqspi: QSPI handle
  * @retval None
  */
static void QSPI_AutoPollingMemReady(OSPI_HandleTypeDef *hqspi)
{
	OSPI_RegularCmdTypeDef     sCommand;
	OSPI_AutoPollingTypeDef sConfig;

  /* Configure automatic polling mode to wait for memory ready ------ */
  sCommand.InstructionMode   = HAL_OSPI_INSTRUCTION_1_LINE;
  sCommand.Instruction       = READ_STATUS_REG_CMD;
  sCommand.AddressMode       = HAL_OSPI_ADDRESS_NONE;
  sCommand.AlternateBytesMode = HAL_OSPI_ALTERNATE_BYTES_NONE;
  sCommand.DataMode          = HAL_OSPI_DATA_1_LINE;
  sCommand.DummyCycles       = 0;
  sCommand.DataDtrMode       = HAL_OSPI_DATA_DTR_DISABLE;
  sCommand.DQSMode  		 = HAL_OSPI_DQS_DISABLE;
  sCommand.SIOOMode          = HAL_OSPI_SIOO_INST_EVERY_CMD;

  sConfig.Match           = 0x00;
  sConfig.Mask            = 0x01;
  sConfig.MatchMode       = HAL_OSPI_MATCH_MODE_AND;
//  sConfig.StatusBytesSize = 1;
  sConfig.Interval        = 0x10;
  sConfig.AutomaticStop   = HAL_OSPI_AUTOMATIC_STOP_ENABLE;
  if (HAL_OSPI_AutoPolling_IT(&hospi1, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief  This function configure the dummy cycles on memory side.
  * @param  hqspi: QSPI handle
  * @retval None
  */
static void QSPI_DummyCyclesCfg(OSPI_HandleTypeDef *hqspi)
{
	OSPI_RegularCmdTypeDef sCommand;
  uint8_t reg;

  /* Read Volatile Configuration register --------------------------- */
  sCommand.InstructionMode   = HAL_OSPI_INSTRUCTION_1_LINE;
  sCommand.Instruction       = READ_VOL_CFG_REG_CMD;
  sCommand.AddressMode       = HAL_OSPI_ADDRESS_NONE;
  sCommand.AlternateBytesMode = HAL_OSPI_ALTERNATE_BYTES_NONE;
  sCommand.DataMode          = HAL_OSPI_DATA_1_LINE;
  sCommand.DummyCycles       = 0;
  sCommand.DataDtrMode       = HAL_OSPI_DATA_DTR_DISABLE;
  sCommand.DQSMode  		 = HAL_OSPI_DQS_DISABLE;
  sCommand.SIOOMode          = HAL_OSPI_SIOO_INST_EVERY_CMD;
  sCommand.NbData            = 1;

  if (HAL_OSPI_Command(&hospi1, &sCommand, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  {
    Error_Handler();
  }

  if (HAL_OSPI_Receive(&hospi1, &reg, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  {
    Error_Handler();
  }

  /* Enable write operations ---------------------------------------- */
  QSPI_WriteEnable(&hospi1);

  /* Write Volatile Configuration register (with new dummy cycles) -- */
  sCommand.Instruction = WRITE_VOL_CFG_REG_CMD;
  MODIFY_REG(reg, 0xF0, (N25Q128A_DUMMY_CYCLES_READ_QUAD << POSITION_VAL(0xF0)));

  if (HAL_OSPI_Command(&hospi1, &sCommand, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  {
    Error_Handler();
  }

  if (HAL_OSPI_Transmit(&hospi1, &reg, HAL_OSPI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
  {
    Error_Handler();
  }
}


void clock_4094(void)
{
	CLK_4094_ON();
	CLK_4094_OFF();
}

void strobe_4094(void)
{
	CS_4094_ON();
	CS_4094_OFF();
}

void data_submit_4094(uint8_t LED_data)
{
        for (uint8_t i=0 ; i<8 ; i++){
            if((LED_data >> i) & 0x01){
            	DATA_4094_ON();
            }
            else{
            	DATA_4094_OFF();
            }

            clock_4094();
        }
        strobe_4094();
}
/* USER CODE END 4 */

/**
  * @brief  Period elapsed callback in non blocking mode
  * @note   This function is called  when TIM6 interrupt took place, inside
  * HAL_TIM_IRQHandler(). It makes a direct call to HAL_IncTick() to increment
  * a global variable "uwTick" used as application time base.
  * @param  htim : TIM handle
  * @retval None
  */
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
  /* USER CODE BEGIN Callback 0 */

  /* USER CODE END Callback 0 */
  if (htim->Instance == TIM6) {
    HAL_IncTick();
  }
  /* USER CODE BEGIN Callback 1 */

  /* USER CODE END Callback 1 */
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
